/*=============================================================================
                       Backtracking: ANAGRAMS
Buckets version. We assume that the word whose anagrams we have to compute, is
made out of d (>=1) characters.
=============================================================================*/
#include  <iostream.h>
const int d=5;             // it is the length of the word
char An[d], Different_chars[d]; int Frequencies[d];
int nofbuckets; int id=0;
void printchar_ar(char An[], int size)
     {for (int i=0; i<size; i=i+1) {cout << An[i] << " ";} }
void printint_ar(int An[], int size)
     {for (int i=0; i<size; i=i+1) {cout << An[i] << " ";} }
//----------------------------------------------------------------------------
void make_buckets(char Wr[], char D_ch[], int Fr[], int & nofbuckets)
    {int i=0; D_ch[0]=Wr[0]; Fr[0]=1; nofbuckets=1;
    while (i < d-1)
       {i=i+1; int j=0;
        while ((j <= nofbuckets-1) && (!(D_ch[j]==Wr[i]))) {j=j+1;};
             if (j > nofbuckets-1)  {D_ch[j]=Wr[i]; Fr[j]=1;
                                     nofbuckets=nofbuckets+1;}
             else {Fr[j]=Fr[j]+1;};};}
//----------------------------------------------------------------------------
void generate()
{int ib=0;
do {if (Frequencies[ib] > 0)
    {An[id]=Different_chars[ib]; id=id+1;
              Frequencies[ib]=Frequencies[ib]-1;
              if (id==d) {printchar_ar(An,d); cout << "\n";}
                         else generate();
              Frequencies[ib]=Frequencies[ib]+1; id=id-1;};
    ib=ib+1;}
while (ib!=nofbuckets);}
/*----------------------------------------------------------------------------
Initially we have to compute from the given word, that is, the array Word, the
array Different_chars of the different characters and the array Frequencies of
the frequency for each different character. We have also to compute the
dimension 'nofbuckets', which stands for 'number of buckets', of those new
arrays.
A BUCKET is a pair of an element in Different_chars and its frequency in
Frequencies. For instance, the bucket <'a',2> tells that we have two a's in the
array Word from which we can take the characters for constructing the required
anagrams.
---------------------------------------------------------------------------- */
void main() {char Word[] = "abbaa";   // input word of dimension d
cout << "Given word:\n" << Word << "\n";
   make_buckets(Word, Different_chars, Frequencies, nofbuckets);
cout << "\nDifferent_chars:  ";
   printchar_ar(Different_chars,nofbuckets);
cout << "\nFrequencies:      ";
   printint_ar(Frequencies,nofbuckets);
cout << "\n\nAnagrams of the given word:\n";
generate();
}
/* input:            output:
------------------------------------------------------------------------------
                     Given word:
                     abbaa

                     Different_chars:  a  b
                     Frequencies:      3  2

                     Anagrams of the given word:
                     a  a  a  b  b
                     a  a  b  a  b
                     a  a  b  b  a
                     a  b  a  a  b
                     a  b  a  b  a
                     a  b  b  a  a
                     b  a  a  a  b
                     b  a  a  b  a
                     b  a  b  a  a
                     b  b  a  a  a
--------------------------------------------------------------------------- */